//Automatic Hand Sanitizer Project
//Hendy Wijaya | BINUS University

#include <LiquidCrystal.h>
LiquidCrystal lcd(9, 8, 7, 6, 5, 4);
int pumpPin=10;
int trigPin=2;
int echoPin=3;
int pingTravelTime;
float distanceToTarget;
float detectionDistance = 4;
int greenPin=11;
int yellowPin=12;

void setup() {
Serial.begin(9600);
lcd.begin(16, 2);
pinMode(pumpPin,OUTPUT);
pinMode(trigPin,OUTPUT);
pinMode(echoPin,INPUT);
pinMode(greenPin, OUTPUT);
pinMode(yellowPin, OUTPUT);
}

void loop() {
//set LCD
lcd.clear();
lcd.setCursor(3, 0);
lcd.print("Automatic");
lcd.setCursor(1, 1);
lcd.print("Hand Sanitizer");
//set ultrasonic sensor
digitalWrite(trigPin,LOW);
digitalWrite(echoPin,LOW);
delayMicroseconds(10);  
digitalWrite(trigPin,HIGH);
delayMicroseconds(10);
digitalWrite(trigPin,LOW);
pingTravelTime=pulseIn(echoPin,HIGH);
delay(25);
//measure the distance
distanceToTarget=(pingTravelTime*0.00676);
Serial.print("Distance to Target: ");
Serial.print(distanceToTarget);
Serial.println(" inch");
delay(500);
  //dispense hand sanitizer
   if (distanceToTarget <= detectionDistance){
     analogWrite (pumpPin, 255);
     digitalWrite(yellowPin, HIGH);
     digitalWrite(greenPin, LOW);
     lcd.clear();
     lcd.setCursor(2, 0);
     lcd.print("Pakai Masker!");
     lcd.setCursor(3, 1);
     lcd.print("Jaga Jarak!");
     delay(500);
    }
    else
    {
    //standby position
      analogWrite (pumpPin, 0);
      digitalWrite(greenPin, HIGH);
      digitalWrite(yellowPin, LOW);
    }
}
